package com.example.es.service.impl;

import cn.hutool.json.JSONUtil;
import com.example.es.document.ESGoodsDocument;
import com.example.es.repository.ESGoodsDocumentRepository;
import com.example.es.service.EsSearchService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.data.elasticsearch.core.ElasticsearchOperations;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * elasticsearch 搜索引擎 service实现
 *
 * @author zhoudong
 * @version 0.1
 * @date 2018/12/13 15:33
 */
@Service
public class EsSearchServiceImpl extends BaseSearchServiceImpl<ESGoodsDocument> implements EsSearchService {
    private Logger log = LoggerFactory.getLogger(getClass());
    @Resource
    private ElasticsearchOperations searchOperations;
    @Resource
    private ESGoodsDocumentRepository ESGoodsDocumentRepository;

    @Override
    public void save(ESGoodsDocument... ESGoodsDocuments) {
        if (ESGoodsDocuments.length > 0) {
            log.info("【保存索引】：{}", JSONUtil.toJsonStr(ESGoodsDocumentRepository
                    .saveAll(Arrays.asList(ESGoodsDocuments))));
        }
    }

    @Override
    public void delete(String id) {
        ESGoodsDocumentRepository.deleteById(id);
    }

    @Override
    public void deleteAll() {
        ESGoodsDocumentRepository.deleteAll();
    }

    @Override
    public ESGoodsDocument getById(String id) {
        return ESGoodsDocumentRepository.findById(id).get();
    }

    @Override
    public List<ESGoodsDocument> getAll() {
        List<ESGoodsDocument> list = new ArrayList<>();
        ESGoodsDocumentRepository.findAll().forEach(list::add);
        return list;
    }

}
